; Disassembly of the file "SONGS.BIN" (C) 1978ish
; Programmed for Dave Nutting Assoc. by Scot L. Norris
;
; CPU Type: Z80 - Bally/Astrocade Home Computer Unit
;
; Created with dZ80 1.50 and TONS of hand disassembly
; Re-assembles correctly with: zmac -i -m SONGS.ASM
;
; Dis-assembled and commented by: Richard C. Degler
; on Thursday, 28 of February 2008 at 03:55 PM
;

; Note: SONGS was a cartridge that Don Gladden claimed
; at the time to be written by George Moses, but it now
; seems that Scot Norris (Dave Nutting's sound expert of
; Bowling + Etc. at about the same time) is the author.
;

; Version 1.1 - Sunday, 12 of February 2011 by RCD
; - Clean-up: replaced all TABs with up to 8 Spaces.
; - Menu 2 / Item 4's comments traded with / Item 5's
;   (the text strings and routines were NOT swapped!)
; - Commented on the target routine of all the CREL's.
; - Corrected the order in which the Tones were sucked,
;   which meant realigning bytes under new column names.
;   Of course, the data itself stayed in the same order!!
;

; Version 1.2 - Friday, 18 of March 2011 by Richard Degler
; - Removed unwanted byte from the end of "PUSHN  $02,$00"
;   at $231D which was being ignored by the defined macro.
; - Just in case somebody wants to place them on a Staff,
;   changed all Note values to Names found in "Music.lib"
;   except for in parts of "Crowd Chant" and "Explosion".
;   Instance of 'A0' being off by 1 in "Doz Wer Da Days".
; - Changed Master Oscillator from '$23' to 'OA3' only in
;   "William Tell", "Bicycle Built 4 2", "Bozos Boo Boos",
;   and "The Sting" since all others are in un-Named Keys.
; - "Aw! Too Bad!", "Meadowlands", and the second part of
;   "The Sting" were almost in the "Key of OA2", which is
;   the only Scale that Note Names are valid in anyway!!1!
; - Added the Staff with DNA Note values and Names below :
;

; Value for Sharp / Natural (based on MASTER Osc. of $47)
; [for Decimal values use "Music.lib" notes in "HVGLIB.H"]
;
;                   $00   =   G8
;                   $01   =   G7
;                   $02   =   C7
;                   $03   =   G6
; [note: many gaps above this line]
;             $04 /  xx   =  DS6   [D6 undefined]
;              xx   $05   =   C6  [CS6 undefined]
; undefined -->      xx       B5
;              xx   $06   =   A5
;              xx   $07   =   G5
;              xx   $08   =   F5
; undefined -->      xx       E5
;             $09 /  xx   =  DS5   [D5 undefined]
;             $0A / $0B    CS5 / C5  (example of both)
; undefined -->      xx       B4
;              xx   $0D       A4  [AS4 undefined]
;             $0E   $0F       G4
;      |----- $10 - $11 ----- F4 -----
;  _   ||           $12       E4
; ( )  ||---- $13 - $14 ----- D4 -----
;  X   ||     $15   $17       C4
; ( X) ||---------- $18 ----- B3 -----  Treble Clef
;  \/\ ||     $1A   $1B       A3
;      ||---- $1D - $1F ----- G3 -----
;      ||     $20   $22       F3
;      |----------- $25 ----- E3 -----
;             $27   $29       D3
;             $2C / $2E   =   C3   Middle C [in Key of OA2]
;                   $31       B2
;      |----- $34 - $37 ----- A2 -----
;      ||     $3B   $3E       G2
;  _   ||---- $42 - $46 ----- F2 -----
; ( \  ||           $4A       E2
;   |. ||---- $4F - $54 ----- D2 -----  Bass Clef
; \_/. ||     $59   $5E       C2
;      ||---------- $64 ----- B1 -----
;      ||     $6A   $70       A1
;      |----- $77 - $7E ----- G1 -----
;             $85   $8D       F1
;                   $96       E1
;             $9F / $A8   =   D1
;             $B2   $BD       C1
;                   $C8       B0
;             $D4   $E1       A0
;             $EE   $FD       G0  [not 'GO']
;

        NOLIST

        INCLUDE "HVGLIB.H"      ; contains old "MUSIC.LIB"

; two lone Defines
GAMEST  EQU     $4F60           ; Top of Game Stack Area

MUSICS  EQU     $4FC0           ; Top of Music Stack Area

        LIST

        ORG     FIRSTC

; L2000:
        DB      $55             ; 'U' Menu Sentinal

                ; Menu Page One Nodes
L2001:                  ; Menu 1 / Item 1
        DW      L2007           ; Next Menu Node
        DW      L2185           ; Text "MOUNTAIN KING"
        DW      L2013           ; Start Mountain King

L2007:                  ; Menu 1 / Item 2
        DW      L200D           ; Next Menu Node
        DW      L2193           ; Text "WILLIAM TELL"
        DW      L201A           ; Start William Tell

L200D:                  ; Menu 1 / Item 3
        DW      L204C           ; Next Menu Node
        DW      L21A0           ; Text "STARWARS LASERS"
        DW      L2021           ; Start Starwars Lasers


L2013:          ; Start First Three Songs
        LD      HL,L229B        ; Play Mountain King
        LD      A,$FC           ; Starts with Three Voices
        JR      L2026                   ; (+$0c)

L201A:  LD      HL,L2311        ; Play William Tell
        LD      A,$0C           ; One Voice
        JR      L2026                   ; (+$05)

L2021:  LD      HL,L23B8        ; Play Starwars Lasers
        LD      A,$FC           ; Three Voices

L2026:          ; Play Menu Page One Songs
        LD      (MUSICS),A      ; Save A for Initial Voice Mask
        LD      SP,GAMEST       ; Set Stack Pointer = $4F60
        PUSH    HL              ; Save Music Score
        CALL    L2172           ; Setup MO, Colors, and ACTINT

        POP     HL              ; Restore Music Score
        LD      A,(MUSICS)      ; Restore Voice Mask

L2034:          ; Play Any Song (Voice Mask in A, Song Score in HL)
        LD      IX,MUSICS       ; Set Music SP = $4FC0
        SYSTEM  BMUSIC          ; Play Music Score

; L203A           Show Menu Page One (Falls through to here on EVERY song start)
        SYSSUK  MENU
        DW      L228F           ; Text "SELECT GAME"
        DW      L2001           ; Menu Page One

L2040:          ; Load Menu Page Two
        LD      SP,GAMEST       ; Set Stack Pointer
        CALL    L2172           ; Setup MO, Colors, and ACTINT

; L2046           Show Menu Page Two
        SYSSUK  MENU
        DW      L21B0           ; Text "MORE SONGS"
        DW      L206A           ; Menu Page Two


                ; Menu Page One Nodes continued
L204C:                  ; Menu 1 / Item 4
        DW      L2052           ; Next Menu Node
        DW      L21BB           ; Text "NATIONAL ANTHEM"
        DW      L20E2           ; Start National Anthem

L2052:                  ; Menu 1 / Item 5
        DW      L2058           ; Next Menu Node
        DW      L21CB           ; Text "DOZ WER DA DAYS"
        DW      L20EA           ; Start Doz Wer Da Days

L2058:                  ; Menu 1 / Item 6
        DW      L205E           ; Next Menu Node
        DW      L21DB           ; Text "CROWD CHANT"
        DW      L20F2           ; Start Crowd Chant

L205E:                  ; Menu 1 / Item 7
        DW      L2064           ; Next Menu Node
        DW      L21E7           ; Text "SPINNING WHEEL"
        DW      L20FA           ; Start Spinning Wheel

L2064:                  ; Menu 1 / Item 8
        DW      $0000           ; NO Next Menu Node
        DW      L21B0           ; Text "MORE SONGS"
        DW      L2040           ; Load Menu Page Two

                ; Menu Page Two Nodes
L206A:                  ; Menu 2 / Item 1
        DW      L207C           ; Next Menu Node
        DW      L21F6           ; Text "BIKE BUILT 4 2"
        DW      L2102           ; Start Bike Built 4 2

L2070:                  ; Menu 3 / Item 7
        DW      L2076           ; Next Menu Node (out of order)
        DW      L2205           ; Text "THE END"
        DW      L210A           ; Start The End

L2076:                  ; Menu 3 / Item 8
        DW      $0000           ; NO Next Menu Node (end of page 3)
        DW      L228F           ; Text "SELECT GAME"
        DW      L20D0           ; Load Menu Page Four

L207C:                  ; Menu 2 / Item 2
        DW      L2082           ; Next Menu Node
        DW      L220D           ; Text "BOZOS BOO BOOS"
        DW      L2112           ; Start Bozos Boo Boos

L2082:                  ; Menu 2 / Item 3
        DW      L2088           ; Next Menu Node
        DW      L221C           ; Text "REVELIE"
        DW      L211A           ; Start Revelie

L2088:                  ; Menu 2 / Item 4
        DW      L208E           ; Next Menu Node
        DW      L222E           ; Text "TAUNT"
        DW      L2122           ; Start Taunt

L208E:                  ; Menu 2 / Item 5
        DW      L2094           ; Next Menu Node
        DW      L2224           ; Text "THE STING"
        DW      L212A           ; Start The Sting

L2094:                  ; Menu 2 / Item 6
        DW      L20A6           ; Next Menu Node
        DW      L2234           ; Text "WOLF WHISTLE"
        DW      L2132           ; Start Wolf Whistle

L209A:                  ; Menu 2 / Item 8
        DW      $0000           ; NO Next Menu Node
        DW      L21B0           ; Text "MORE SONGS"
        DW      L20A0           ; Load Menu Page Three


                ; Show Menu Page Three
L20A0:  SYSSUK  MENU
        DW      L21B0           ; Text "MORE SONGS"
        DW      L20AC           ; Menu Page Three


L20A6:                  ; Menu 2 / Item 7
        DW      L209A           ; Next Menu Node
        DW      L2241           ; Text "AW! TOO BAD!"
        DW      L213A           ; Start Aw! Too Bad!

                ; Menu Page Three Nodes
L20AC:                  ; Menu 3 / Item 1
        DW      L20B2           ; Next Menu Node
        DW      L224E           ; Text "EXPLOSION"
        DW      L2142           ; Start Explosion

L20B2:                  ; Menu 3 / Item 2
        DW      L20B8           ; Next Menu Node
        DW      L2258           ; Text "CLEMENTINE"
        DW      L214A           ; Start Clementine

L20B8:                  ; Menu 3 / Item 3
        DW      L20BE           ; Next Menu Node
        DW      L2263           ; Text "3 TAGS"
        DW      L2152           ; Start 3 Tags

L20BE:                  ; Menu 3 / Item 4
        DW      L20C4           ; Next Menu Node
        DW      L226A           ; Text "MEADOWLANDS"
        DW      L215A           ; Start Meadowlands

L20C4:                  ; Menu 3 / Item 5
        DW      L20CA           ; Next Menu Node
        DW      L2276           ; Text "ANCHORS AWEIGH"
        DW      L2162           ; Start Anchors Aweigh

L20CA:                  ; Menu 3 / Item 6
        DW      L2070           ; Next Menu Node
        DW      L2285           ; Text "LIDA ROSE"
        DW      L216A           ; Start Lida Rose


L20D0:            ; Show Menu Page Four
        SYSSUK  MENU
        DW      L228F           ; Text "SELECT GAME"
        DW      L20D6           ; Load Menu Page Four


                ; Menu Page Four Node (First item only)
L20D6:                  ; Menu 4 / Item 1
        DW      MENUST          ; System Menu Start Node
        DW      L21B5           ; Text "SONGS" (end of "MORE SONGS")
        DW      L20DC           ; Reload Menu Page One


L20DC:                  ; Reshow Menu Page One (from Page Four only!)
        SYSSUK  MENU
        DW      L21B0           ; Text "MORE SONGS" (NOT shown on restart!!)
        DW      L2001           ; Load Menu Page One


L20E2:          ; Start All Other Songs (First Three Starts Above)
        LD      HL,L2494        ; Play National Anthem
        LD      A,$0C           ; Starts with One Voice
        JP      L2026

L20EA:  LD      HL,L250C        ; Play Doz Wer Da Days
        LD      A,$0C           ; One Voice
        JP      L2026

L20F2:  LD      HL,L25A5        ; Play Crowd Chant
        LD      A,$0C           ; One Voice
        JP      L2026

L20FA:  LD      HL,L263C        ; Play Spinning Wheel
        LD      A,$FC           ; Three Voices
        JP      L2026

L2102:  LD      HL,L272C        ; Play Bike Built 4 2
        LD      A,$FC           ; Three Voices
        JP      L2034

L210A:  LD      HL,L27FE        ; Play The End
        LD      A,$0C           ; One Voice
        JP      L2034

L2112:  LD      HL,L282A        ; Play Bozos Boo Boos
        LD      A,$0C           ; One Voice
        JP      L2034

L211A:  LD      HL,L284F        ; Play Revelie
        LD      A,$CC           ; Two Voices
        JP      L2034

L2122:  LD      HL,L2882        ; Play Taunt
        LD      A,$FE           ; Three Voices and Vibrato
        JP      L2034

L212A:  LD      HL,L28A1        ; Play The Sting
        LD      A,$FC           ; Three Voices
        JP      L2034

L2132:  LD      HL,L29D2        ; Play Wolf Whistle
        LD      A,$0C           ; One Voice
        JP      L2034

L213A:  LD      HL,L2A0B        ; Play Aw! Too Bad!
        LD      A,$CC           ; Two Voices
        JP      L2034

L2142:  LD      HL,L2A53        ; Play Explosion
        LD      A,$FC           ; Three Voices
        JP      L2034

L214A:  LD      HL,L2A84        ; Play Clementine
        LD      A,$0C           ; One Voice
        JP      L2034

L2152:  LD      HL,L2AFA        ; Play 3 Tags
        LD      A,$0C           ; One Voice
        JP      L2034

L215A:  LD      HL,L2BEF        ; Play Meadowlands
        LD      A,$0C           ; One Voice
        JP      L2034

L2162:  LD      HL,L2CB6        ; Play Anchors Aweigh
        LD      A,$FC           ; Three Voices
        JP      L2034

L216A:  LD      HL,L2D77        ; Play Lida Rose
        LD      A,$FC           ; Three Voices
        JP      L2034

L2172:  LD      A,$C0           ; Set Master Oscillator
        OUT     ($0A),A         ; &(10)=192

        SYSSUK  COLSET          ; Set Colors
        DW      L217D           ; to Color Table

        SYSTEM  ACTINT          ; Turn on Interrupts
        RET


L217D:          ; Color Table
        DB      $04,$0A,$07,$63 ; &(7) to &(4) - Grey, Blue, White, Orange
        DB      $10,$44,$55,$22 ; &(3) to &(0) - Dark Blue, Pink, Peach, Purple


                ; Text Strings
L2185:                  ; "Mountain King" text (Null Terminated)
        DB      'M','O','U','N','T','A','I','N',' ','K','I','N','G',$00

L2193:                  ; "William Tell" text
        DB      'W','I','L','L','I','A','M',' ','T','E','L','L',$00

L21A0:                  ; "Starwars Lasers" text
        DB      'S','T','A','R','W','A','R','S',' ','L','A','S','E','R','S',$00

L21B0:                  ; "More Songs" and "Songs" texts
        DB      'M','O','R','E',' '
L21B5:  DB      'S','O','N','G','S',$00

L21BB:                  ; "National Anthem" text
        DB      'N','A','T','I','O','N','A','L',' ','A','N','T','H','E','M',$00

L21CB:                  ; "Doz Wer Da Days" text
        DB      'D','O','Z',' ','W','E','R',' ','D','A',' ','D','A','Y','S',$00

L21DB:                  ; "Crowd Chant" text
        DB      'C','R','O','W','D',' ','C','H','A','N','T',$00

L21E7:                  ; "Spinning Wheel" text
        DB      'S','P','I','N','N','I','N','G',' ','W','H','E','E','L',$00

L21F6:                  ; "Bike Built 4 2" text
        DB      'B','I','K','E',' ','B','U','I','L','T',' ','4',' ','2',$00

L2205:                  ; "The End" text
        DB      'T','H','E',' ','E','N','D',$00

L220D:                  ; "Bozos Boo Boos" text
        DB      'B','O','Z','O','S',' ','B','O','O',' ','B','O','O','S',$00

L221C:                  ; "Revelie" text
        DB      'R','E','V','E','L','I','E',$00

L2224:                  ; "The Sting" text
        DB      'T','H','E',' ','S','T','I','N','G',$00

L222E:                  ; "Taunt" text
        DB      'T','A','U','N','T',$00

L2234:                  ; "Wolf Whistle" text
        DB      'W','O','L','F',' ','W','H','I','S','T','L','E',$00

L2241:                  ; "Aw! Too Bad!" text
        DB      'A','W','!',' ','T','O','O',' ','B','A','D','!',$00

L224E:                  ; "Explosion" text
        DB      'E','X','P','L','O','S','I','O','N',$00

L2258:                  ; "Clementine" text
        DB      'C','L','E','M','E','N','T','I','N','E',$00

L2263:                  ; "3 Tags" text
        DB      '3',' ','T','A','G','S',$00

L226A:                  ; "Meadowlands" text
        DB      'M','E','A','D','O','W','L','A','N','D','S',$00

L2276:                  ; "Anchors Aweigh" text
        DB      'A','N','C','H','O','R','S',' ','A','W','E','I','G','H',$00

L2285:                  ; "Lida Rose" text
        DB      'L','I','D','A',' ','R','O','S','E',$00

L228F:                  ; "Select Game" text
        DB      'S','E','L','E','C','T',' ','G','A','M','E',$00


                ; Music Scores
L229B:                  ; "Mountain King" music score (Three Voices Mask = $FC)
        OUTPUT  $04,$81         ; Set Vibrato Frequency and Range (VF = 1, VR = 2)
                                        ; Note: If the OUTPUT macro in HVGLIB.H used
                                        ; "DB     $80+((PORT)&($0F))" instead of $7F
                                        ; these could use the actual outport numbers
        LEGSTA                  ; Set Legato (Slur Notes together)
        PUSHN   $0F             ; Save Number of Repeats on Music Stack
L229F:
        MASTER  $80             ; Set Master Oscillator
        CREL    $0A             ; Call Forward Relative to L22AC

        MASTER  $40             ; Resume here
        CREL    $07             ; do L22AC again

        MASTER  $20
        CREL    $04             ; do L22AC etc.

        DSJNZ   L229F           ; Decrement Top of Music Stack and Jump if Not Zero

        QUIET                   ; Quit Playing Music

; L22AC
        VOLUME  $00,$07         ; Set Volumes (VB&VA, NM&VC)
        CREL    $09             ; Call Relative to L22B9

        VOLUME  $30,$07         ; etc.
        CREL    $05             ; do L22B9

        VOLUME  $54,$07
        CREL    $01             ; do L22B9

        RET

; L22B9:
        CALL    L22F8

        ; Duration= TC= TB= TA=
        NOTE3   $1A, G1,AS2, D3 ; Play for Duration*60th second Three Voices
        NOTE3   $0D,FS1, A2,CS3 ; Repeat for next note
        NOTE3   $0D, D1, F2, A2
        NOTE3   $1A,FS1, A2,CS3
        NOTE3   $0D, F1,GS2, C3
        NOTE3   $0D,CS1, D2,GS2
        NOTE3   $1A, F1,GS2, C3
        CALL    L22F8

        NOTE3   $0D, G1,AS2, D3
        NOTE3   $0D, C2,DS3, G3
        NOTE3   $0D,AS1,CS3, F3
        NOTE3   $0D, G1,AS2, D3
        NOTE3   $0D,DS1,FS2,AS2
        NOTE3   $0D, G1,AS2, D3
        NOTE3   $2A,AS1,CS3, F3
        RET

L22F8:
        NOTE3   $0D, C1,DS2, G2
        NOTE3   $0D, D1, F2, A2
        NOTE3   $0D,DS1,FS2,AS2
        NOTE3   $0D, F1,GS2, C3
        NOTE3   $0D, G1,AS2, D3
        NOTE3   $0D,DS1,FS2,AS2
        RET

L2311:                  ; "William Tell" music score (One Voice Mask = $0C)
        MASTER  $26
        VOLUME  $55,$07
        PUSHN   $03
L2317:
        VOICEM  $0C             ; Voice Mask (TA&TB&TC&VF&NV) only TC on
        OUTPUT  $01,         G8 ; Set TA directly
        OUTPUT  $02,     G8     ; Set TB ditto
        PUSHN   $02
L231E:
        ; Duration= TC=
        NOTE1   $07, G1         ; Play for Duration*60th second One Voice
        NOTE1   $07, G1
        NOTE1   $2A, G1
        DSJNZ   L231E

        NOTE1   $07, G1
        NOTE1   $07, G1
        NOTE1   $0E, G1
        NOTE1   $0E, E1
        NOTE1   $0E, C1
        NOTE1   $0E, E1
        NOTE1   $0E, G1
        NOTE1   $0E, E1
        NOTE1   $0E, G1
        NOTE1   $0E, C2
        PUSHN   $02
L233C:
        NOTE1   $2A, G1
        NOTE1   $07, G1
        NOTE1   $07, G1
        DSJNZ   L233C

        PUSHN   $04
        OUTPUT  $01,         B0
        OUTPUT  $02,     D1
L234A:
        NOTE1   $0E, G1
        NOTE1   $07, G1
        NOTE1   $07, G1
        NOTE1   $0E, G1
        NOTE1   $0E, G1
        DSJNZ   L234A

        NOTE1   $48, G1
        PUSHN   $02
L235A:
        OUTPUT  $01,         G8
        OUTPUT  $02,     G8
        CALL    L23A0

        CALL    L23B1

        NOTE1   $07, D1
        NOTE1   $07, D1
        NOTE1   $0E, G1
        NOTE1   $07, B1
        NOTE1   $07, B1
        NOTE1   $0E, A1
        NOTE1   $0E,FS1
        NOTE1   $0E, D1
        CALL    L23A0

        VOICEM  $CC             ; Voice Mask = TA and TC on
        ; Duration= TC=     TA=
        NOTE2   $07, G1,     G0
        NOTE2   $07, G1,     G0
        NOTE2   $2A, D2,     D1
        NOTE2   $07, B1,     B0
        NOTE2   $07, B1,     B0
        NOTE2   $0E, G1,     G0
        NOTE2   $0E, B1,     B0
        NOTE2   $0E, G1,     G0

        MASTER  $20
        OUTPUT  $02,     G8
        VOICEM  $0C
        DSJNZ   L235A

        MASTER  OA3             ; [$23 for Key of A3]
        DSJNZ   L2317

        QUIET

L23A0:
        CALL    L23B1

        CALL    L23B1

        ; Duration= TC=
        NOTE1   $07, D1
        NOTE1   $07, D1
        NOTE1   $0E, G1
        NOTE1   $0E, A1
        NOTE1   $0E, B1
        RET

L23B1:
        NOTE1   $07, D1
        NOTE1   $07, D1
        NOTE1   $0E, D1
        RET

L23B8:                  ; "Starwars Lasers" music score (Voices Mask = $FC)
        LEGSTA                  ; Set Legato
        PUSHN   $06
L23BA:
        VOLUME  $77,$17         ; NM = 1
        MASTER  $74
        OUTPUT  $07,$50         ; NV = $50
        CALL    L248F

        MASTER  $00
        OUTPUT  $07,$80         ; NV = $80
        CALL    L248F

        OUTPUT  $07,$40         ; NV = $40
        MASTER  $68
        CALL    L248F

        MASTER  $54
        OUTPUT  $07,$30         ; NV = $30
        CALL    L248F

        MASTER  $40
        OUTPUT  $07,$20         ; NV = $20
        CALL    L248A

        MASTER  $38
        OUTPUT  $07,$20         ; NV = $20
        CALL    L248A

        PUSHN   $03
        MASTER  $2A
        OUTPUT  $07,$10         ; NV = $10
L23EC:
        CALL    L248A

        DSJNZ   L23EC

        MASTER  $3A
        OUTPUT  $07,$20         ; NV = $20
        CALL    L2485

        VOLUME  $55,$15         ; NM = 1
        MASTER  $48
        OUTPUT  $07,$28         ; NV = $28
        CALL    L2485

        VOLUME  $33,$13         ; NM = 1
        MASTER  $60
        OUTPUT  $07,$42         ; NV = $42
        CALL    L2485

        VOLUME  $22,$12         ; NM = 1
        MASTER  $80
        OUTPUT  $07,$60         ; NV = $60
        CALL    L2485

        PUSHN   $03
        VOLUME  $11,$11         ; NM = 1
        MASTER  $A0
        OUTPUT  $07,$80         ; NV = $60
L241F:
        CALL    L2485

        DSJNZ   L241F

        DSJNZ   L23BA

        REST    $1E
        PUSHN   $06
L242B:
        MASTER  $48
        OUTPUT  $07,$30         ; NV = $30
        VOLUME  $77,$17         ; NM = 1
        CALL    L2480

        MASTER  $38
        OUTPUT  $07,$20         ; NV = $20
        CALL    L2480

        MASTER  $2A
        OUTPUT  $07,$10         ; NV = $10
        CALL    L2480

        MASTER  $38
        OUTPUT  $07,$20         ; NV = $20
        CALL    L2480

        MASTER  $4A
        OUTPUT  $07,$30         ; NV = $30
        CALL    L2480

        MASTER  $60
        OUTPUT  $07,$48         ; NV = $48
        CALL    L2480

        DSJNZ   L242B

        REST    $1E
        PUSHN   $06
L245E:
        VOICEM  $0C
        MASTER  $26
        VOLUME  $00,$07         ; NM = 0
        OUTPUT  $07,$1C         ; NV = $1C
        CREL    $09             ; do L2471

        MASTER  $56
        OUTPUT  $07,$32         ; NV = $32
        CREL    $04             ; do L2471

        DSJNZ   L245E

        QUIET

; L2471:
        ; Duration= TC=
        NOTE1   $01, C3
        NOTE1   $01,AS2
        NOTE1   $01,GS2
        NOTE1   $01,FS2
        NOTE1   $01, E2
        NOTE1   $01, D2
        NOTE1   $01, C2
        RET

L2480:
        NOTE1   $03,GS4
        NOTE1   $01, C7
        RET

L2485:
        NOTE1   $04, C6
        NOTE1   $03, C7
        RET

L248A:
        NOTE1   $02,GS4
        NOTE1   $01, A5
        RET

L248F:
        NOTE1   $01, G4
        NOTE1   $01, G6
        RET

L2494:                  ; "National Anthem" music score (Voices Mask = $0C)
        MASTER  $20
        VOLUME  $66,$07
        ; Duration= TC=
        NOTE1   $18, G1
        OUTPUT  $01,         E1 ; Set TA
        OUTPUT  $02,     G1     ; Set TB
        NOTE1   $18, C2
        NOTE1   $18, C2
        NOTE1   $0C, C2
        NOTE1   $0C, B1
        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $18, A1, F1, C1
        NOTE3   $18, A1, F1, C1
        NOTE3   $18, A1, E1,CS1
        NOTE3   $18, D2, F1, A1
        VOICEM  $0C
        NOTE1   $0C, F2
        NOTE1   $0C, E2
        NOTE1   $0C, D2
        NOTE1   $0C, C2
        VOICEM  $FC
        NOTE3   $1A, C2,GS1, F1
        NOTE3   $30, B1, G1, D1
        NOTE3   $0E, G1, G8, G8
        NOTE3   $0E, G1, G8, G8
        NOTE3   $24, C2, G1, E1
        NOTE3   $0C, D2, B1, G1
        NOTE3   $0E, E2, C2, G1
        NOTE3   $10, F2, D2, G1
        NOTE3   $24, G2, E2, C2
        NOTE3   $36, C3, G2, E2
        REST    $12
        NOTE3   $12, C2, F1, A1
        NOTE3   $12, D2, F1, A1
        NOTE3   $36, E2, C2, G1
        NOTE3   $10, F2, D2, G1
        NOTE3   $16, D2, B1, G1
        NOTE3   $24, C2, E1, G1
        NOTE3   $48, C2, E2, G2
        QUIET

L250C:                  ; "Doz Wer Da Days" music score (Voices Mask = $0C)
        VOLUME  $44,$07
        OUTPUT  $04,$81         ; VF = 1, VR = 2
        MASTER  $30
        CREL    $07             ; do L251B

        MASTER  $29
        CREL    $04             ; do L251B (Lagato and Staccato reversed)

        MASTER  $26
        CREL    $01             ; do L251B

        QUIET

; L251B:
        OUTPUT  $01,         G8 ; TA = 0
        OUTPUT  $02,     G8     ; TB = 0
        VOICEM  $C0
        ; Duration=         TA=
        NOTE1   $15,         C2
        NOTE1   $07,         D2
        NOTE1   $15,         F2
        NOTE1   $07,         G2
        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $1C, A2, F2, F1
        VOICEM  $F0
        ; Duration=     TB= TA=
        NOTE2   $1C,     F2,$E0 ; [A0 - 1 ??]
        VOICEM  $FC
        NOTE3   $28, F2,AS2, C1
        NOTE3   $28, F2, A2, F1
        LEGSTA                  ; Set Legato
        REST    $02
        NOTE3   $15, F2, D2, C1
        VOICEM  $C0
        NOTE1   $07,         G2
        NOTE1   $15,         A2
        NOTE1   $07,         C3
        VOICEM  $FC
        NOTE3   $1C, D3, F2, F1
        VOICEM  $C0
        NOTE1   $1C,         A2
        NOTE1   $1C,         A2
        LEGSTA                  ; Set Staccato
        VOICEM  $CC
        ; Duration= TC=     TA=
        NOTE2   $1C, A2,    CS1
        VOICEM  $FC
        NOTE3   $38, A2, C1, F1
        LEGSTA                  ; Set Legato
        NOTE3   $15, D3, F2, B1
        VOICEM  $C0
        NOTE1   $07,         C3
        VOICEM  $FC
        NOTE3   $15, A2, C1, A0
        VOICEM  $C0
        NOTE1   $07,         G2
        VOICEM  $FC
        NOTE3   $1C, F2, D2, D1
        VOICEM  $C0
        NOTE1   $1C,         D2
        LEGSTA                  ; Set Staccato
        VOICEM  $FC
        NOTE3   $28, D2, G1, B2
        NOTE3   $28, D2,AS2, G1
        LEGSTA                  ; Set Legato
        NOTE3   $15, C3, G2,AS2
        VOICEM  $C0
        NOTE1   $07,         A2
        NOTE1   $15,         G2
        LEGSTA                  ; Set Staccato
        NOTE1   $28,         F2
        VOICEM  $FC
        NOTE3   $52, F2, F1, C2
        LEGSTA                  ; Set Legato
        REST    $37
        RET

L25A5:                  ; "Crowd Chant" music score (Voices Mask = $0C)
        MASTER  $60
        LEGSTA                  ; Set Legato
        OUTPUT  $07,$61         ; NV = $61
        PUSHN   $05
L25AB:
        OUTPUT  $01,        $20 ; Set TA
        OUTPUT  $02,    $10     ; Set TB
        CALL    L2621

        OUTPUT  $01,        $30 ; [use Non-Name notes for this part]
        OUTPUT  $02,    $20
        CALL    L2621

        OUTPUT  $01,        $40
        OUTPUT  $02,    $25
        CALL    L2621

        VOLUME  $21,$12         ; NM = 1
        PUSHN   $07
L25C4:
        CALL    L2639

        DSJNZ   L25C4

        DSJNZ   L25AB

        MASTER  $1E
        CALL    L25E2

        CALL    L25FF

        MASTER  $1C
        CREL    $0A             ; do L25E2

        CALL    L25FF                   ; (Sets Staccato instead)

        MASTER  $1A
        CREL    $04             ; do L25E2

        CALL    L25FF

        QUIET

L25E2:
        VOLUME  $70,$07         ; NM = 0
        VOICEM  $FD             ; NV on
        LEGSTA                  ; Set Staccato
        ; Duration= NV= TC= TB= TA=
        NOTE4   $08,$00, C2, C1, G8
        VOICEM  $3C             ; NV off
        ; Duration= TC= TB=
        NOTE2   $08, D2, D1
        NOTE2   $08, E2, E1
        NOTE2   $18, G2, G1
        NOTE2   $08, E2, E1
        NOTE2   $30, G2, G1
        RET

L25FF:
        VOICEM  $FD             ; NV on
        MASTER  $00
        VOLUME  $77,$17         ; NM = 1
        LEGSTA                  ; Set Legato
        PUSHN   $04
L2608:
        CALL    L261B

        DSJNZ   L2608

        VOLUME  $76,$16         ; NM = 1
        CREL    $09             ; do L261B

        VOLUME  $65,$15         ; NM = 1
        CREL    $05             ; do L261B

        VOLUME  $53,$13         ; NM = 1
        CREL    $01             ; do L261B

        RET

L261B:  ; [more Non-Name notes here]
        ; Duration= NV= TC= TB= TA=
        NOTE4   $1E,$01,$03,$3C,$50
        RET

L2621:
        VOLUME  $67,$16         ; NM = 1
        CALL    L2639

        VOLUME  $77,$17         ; NM = 1
        CREL    $0E             ; do L2639

        CREL    $0D             ; do L2639

        VOLUME  $56,$15         ; NM = 1
        CREL    $09             ; do L2639

        VOLUME  $44,$14         ; NM = 1
        CREL    $05             ; do L2639

        VOLUME  $33,$13         ; NM = 1
        CREL    $01             ; do L2639

        RET

L2639:
        ; Duration= TC=
        NOTE1   $05,  G5
        RET

L263C:                  ; "Spinning Wheel" music score (Voices Mask = $FC)
        CALL    L269F
        REST    $01
        VOICEM  $C0
        MASTER  $40
        VOLUME  $05,$00
        CALL    L26E2

        CALL    L2720

        VOLUME  $45,$06
        PUSHN   $02
L2652:
        PUSHN   $02
L2653:
        CALL    L26E2

        CALL    L2720

        DSJNZ   L2653

        CALL    L26E2

        ; Duration=         TA=
        NOTE1   $0D,         A2
        NOTE1   $0C,         B2
        CALL    L2719

        VOICEM  $0C
        PUSHN   $04
L2669:  ; Duration= TC=
        NOTE1   $0C, C3
        REST    $01
        NOTE1   $0D, B2
        DSJNZ   L2669

        NOTE1   $0C, C3
        OUTPUT  $01,         F2 ; Set TA
        OUTPUT  $02,     C3     ; Set TB
        NOTE1   $0D, B2
        NOTE1   $0C, C3
        NOTE1   $0D, B2
        NOTE1   $19, C3
        REST    $01
        VOICEM  $C0
        NOTE1   $0C,         D2
        NOTE1   $0D,        DS2
        DSJNZ   L2652

        PUSHN   $02
L268C:
        CALL    L26E2

        CALL    L2720

        DSJNZ   L268C

        CALL    L269F

        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $3C, G2, B1, G1
        QUIET

L269F:
        VOICEM  $FC
        MASTER  $20
        VOLUME  $53,$03
        CALL    L26BB

        VOICEM  $FC
        NOTE3   $1E, B2, B1, G1
        VOICEM  $C0
        NOTE1   $1E,         G2
        NOTE1   $1E,         G2
        CALL    L26BB

        VOICEM  $FC
        RET

L26BB:
        VOICEM  $FC
        NOTE3   $28, D3, B1, G1
        VOICEM  $C0
        NOTE1   $0F,         E3
        NOTE1   $0F,         D3
        NOTE1   $0F,         C3
        VOICEM  $FC
        NOTE3   $1E, B2, G1, D1
        VOICEM  $C0
        NOTE1   $1E,         G2
        NOTE1   $1E,         G2
        VOICEM  $FC
        NOTE3   $1E, A2, C1,FS1
        VOICEM  $C0
        NOTE1   $1E,         D1
        NOTE1   $1E,         D1
        RET

L26E2:
        CALL    L270B

        NOTE1   $19,         E2
        OUTPUT  $03, E3         ; Set TC
        NOTE1   $0C,         E1
        NOTE1   $0D,        GS1
        CALL    L2712

        NOTE1   $19,         A1
        REST    $01
        NOTE1   $0C,         C2
        NOTE1   $0D,        CS2
        CALL    L2719

        NOTE1   $19,         D2
        OUTPUT  $03, D3
        NOTE1   $0D,         D1
        NOTE1   $0D,        FS1
        CALL    L2725

        NOTE1   $19,         G1
        REST    $01
        RET

L270B:
        OUTPUT  $01,         E2
        OUTPUT  $02,    GS2
        OUTPUT  $03, D3
        RET

L2712:
        OUTPUT  $01,         A1
        OUTPUT  $02,     G2
        OUTPUT  $03,CS3
        RET

L2719:
        OUTPUT  $01,         D2
        OUTPUT  $02,    FS2
        OUTPUT  $03, C3
        RET

L2720:
        NOTE1   $0D,         B1
        NOTE1   $0C,         D2
        RET

L2725:
        OUTPUT  $01,         G2
        OUTPUT  $02,     D3
        OUTPUT  $03, B2
        RET

L272C:                  ; "Bike Built 4 2" music score (Voices Mask = $FC)
        MASTER  OA3             ; [$23 for Key of A3]
        VOLUME  $45,$07
        LEGSTA                  ; Set Legato
        OUTPUT  $04,$81         ; VF = 1, VR = 2
        ; Duration= TC= TB= TA=
        NOTE3   $3C, D3, G2, B2
        NOTE3   $3C, B2, G2, D2
        NOTE3   $3C, G2, D2, B1
        NOTE3   $3C, D2, G1, B1
        NOTE3   $14, E2, C2, G1
        VOICEM  $0C
        ; Duration= TC=
        NOTE1   $14,FS2
        NOTE1   $14, G2
        NOTE1   $28, E2
        NOTE1   $14, G2
        VOICEM  $FC
        NOTE3   $3C, D2, G1, B1
        NOTE3   $3A, D2, G1, B1
        REST    $02
        NOTE3   $3C, A2, D2,FS2
        NOTE3   $3C, D3, A2,FS2
        NOTE3   $3C, B2, G2, D2
        NOTE3   $3C, G2, D2, B1
        NOTE3   $14, E2, A1,CS2
        VOICEM  $0C
        NOTE1   $14,FS2
        NOTE1   $14, G2
        NOTE1   $28, A2
        NOTE1   $14, B2
        OUTPUT  $01,         D2 ; Set TA
        OUTPUT  $02,    FS2     ; Set TB
        NOTE1   $4E, A2
        REST    $02
        NOTE1   $14, B2
        NOTE1   $14, C3
        NOTE1   $14, B2
        NOTE1   $14, A2
        NOTE1   $28, D3
        NOTE1   $14, B2
        VOICEM  $FC
        NOTE3   $14, A2, B2, D1
        VOICEM  $0C
        NOTE1   $4E, G2
        REST    $02
        NOTE1   $14, A2
        NOTE1   $28, B2
        NOTE1   $14, G2
        VOICEM  $FC
        NOTE3   $28, E2, C2, G1
        NOTE3   $14, G2, E2, C2
        NOTE3   $14, E2, G1, B1
        VOICEM  $0C
        NOTE1   $4E, D2
        REST    $02
        NOTE1   $14, D2
        NOTE1   $28, G2
        NOTE1   $14, B2
        VOICEM  $FC
        NOTE3   $28, A2, D2,FS2
        NOTE3   $14, D2, A1,FS1
        NOTE3   $28, G2, D2, B1
        NOTE3   $14, B2, G2, D2
        NOTE3   $28, A2, D2,FS2
        VOICEM  $0C
        NOTE1   $0A, B2
        NOTE1   $0A, C3
        VOICEM  $FC
        NOTE3   $14, D3, G2, B2
        NOTE3   $14, B2, G2, D2
        NOTE3   $14, G2, D2, B1
        NOTE3   $28, A2, D2,FS2
        NOTE3   $14, D2,FS2, A1
        NOTE3   $14, G2, D2, B1
        VOICEM  $F0
        ; Duration=     TB= TA=
        NOTE2   $14,     C2, E2
        NOTE2   $14,    DS2, C2
        NOTE2   $28,     D2, B1
        QUIET

L27FE:                  ; "The End" music score (Voices Mask = $0C)
        MASTER  $40
        VOLUME  $55,$07
        CALL    L281F

        ; Duration= TC=
        NOTE1   $06, D2
        NOTE1   $12, D2
        NOTE1   $0C, D2
        NOTE1   $06, A1
        NOTE1   $13, B1
        CALL    L281F

        NOTE1   $0E, G1
        REST    $14
        VOICEM  $FE             ; VR on
        ; Duration= VR= TC= TB= TA=
        NOTE4   $44,$82, G3, B2, D2
        QUIET

L281F:  ; Duration= TC=
        NOTE1   $14, G2
        NOTE1   $06, D2
        NOTE1   $0E, E2
        NOTE1   $06, D2
        NOTE1   $0E, B1
        RET

L282A:                  ; "Bozos Boo Boos" music score (Voices Mask = $0C)
        MASTER  OA3             ; [$23 for Key of A3]
        VOLUME  $00,$04
        ; Duration= TC=
        NOTE1   $14, C3
        NOTE1   $14, B2
        NOTE1   $14,AS2
        NOTE1   $14, A2
        NOTE1   $14,GS2
        NOTE1   $14, G2
        OUTPUT  $04,$81         ; VF = 1, VR = 2
        LEGSTA                  ; Set Legato
        PUSHN   $03
L283F:
        CREL    $06             ; do L2846

        NOTE1   $28,FS2
        DSJNZ   L283F

        QUIET

; L2846:
        NOTE1   $01, F2
        NOTE1   $01,$45         ; [F2 - 1 slide up to FS2 + 1]
        NOTE1   $01,$44         ; [F2 - 2]
        NOTE1   $01,$43         ; [F2 - 3]
        RET

L284F:                  ; "Revelie" music score (Voices Mask = $CC)
        MASTER  $12
        CALL    L2862

        ; Duration= TC=     TA=
        NOTE2   $06, C2,     C3
        NOTE2   $06, D2,     D3
        LEGSTA                  ; Set Legato
        NOTE2   $18, E2,     E3
        NOTE2   $18, C2,     C3
        QUIET

L2862:
        PUSHN   $03
        REST    $14
L2865:
        REST    $0B
        VOLUME  $05,$05
        NOTE2   $06, G1,     G2
        VOLUME  $07,$07
        NOTE2   $06, C2,     C3
        NOTE2   $06, E2,     E3
        NOTE2   $06, C2,     C3
        NOTE2   $06, G1,     G2
        REST    $05
        DSJNZ   L2865

        RET

L2882:                  ; "Taunt" music score (Voices Mask = $FE)
        MASTER  $30
        VOLUME  $44,$04
        PUSHN   $02
L2888:
        VOICEM  $FE             ; VR on
        ; Duration= VR= TC= TB= TA=
        NOTE4   $1E,$82,AS2, G2,DS2
        VOICEM  $0C
        REST    $02
        ; Duration= TC=
        NOTE1   $0A,AS2
        NOTE1   $1E,AS1
        NOTE1   $0A, C3
        NOTE1   $28,AS2
        NOTE1   $28,AS1
        DSJNZ   L2888

        QUIET

L28A1:                  ; "The Sting" music score (Voices Mask = $FC)
        LEGSTA                  ; Set Legato
        PUSHN   $02
L28A3:
        MASTER  OA3             ; [$23 for Key of A3]
        CALL    L296E

        CALL    L299B

        ; Duration= TC= TB= TA=
        NOTE3   $18, E1, G1, C3
        CALL    L296E

        NOTE3   $18, E1, C2, G8
        NOTE3   $0C,DS1, C2, A2
        NOTE3   $0C,DS1, C2, G2
        NOTE3   $0C, D1, C2,FS2
        NOTE3   $0C, D1, A2, C2
        NOTE3   $0C, D1,FS1, C3
        NOTE3   $0C, D1,FS1, E3
        NOTE3   $0C, D1, G8, E3
        NOTE3   $0C, D1, G8, D3
        NOTE3   $0C, F1, A1, C3
        NOTE3   $0C, F1, A1, A2
        NOTE3   $18, G1, B1, D3
        NOTE3   $18, G0, G1, D3
        NOTE3   $18, A0, A1, D2
        CALL    L296E

        CALL    L299B

        NOTE3   $18, G1, E2, C3
        NOTE3   $0C, C2, C3, G8
        NOTE3   $0C, D2, D3, G8
        NOTE3   $0C, C1, C2, E3
        NOTE3   $0C, C1, C2, C3
        NOTE3   $0C, G1, E2, D3
        NOTE3   $0C, G1, C2, E3
        NOTE3   $0C,AS0,AS1, E3
        NOTE3   $0C,AS0,AS1, C3
        NOTE3   $0C, G1, E2, D3
        NOTE3   $0C, G1, E2, C3
        NOTE3   $0C, A0, A1, E3
        NOTE3   $0C, A0, A1, C3
        NOTE3   $0C, A1, F2, D3
        NOTE3   $0C, A1, C2, E3
        NOTE3   $0C,GS0,GS1, E3
        NOTE3   $0C,GS0,GS1, C3
        NOTE3   $0C,GS1, C2, D3
        NOTE3   $0C,GS1, F2, C3
        NOTE3   $0C, G0, G1, E3
        NOTE3   $0C, G0, G1, C3
        NOTE3   $0C, G1, F2, D3
        NOTE3   $0C, G1, G2, E3
        NOTE3   $0C, G0, G2, E3
        NOTE3   $0C, G0, D2, B2
        NOTE3   $18, G1, F2, D3
        MASTER  $46             ; [OA2 - 1 ?? almost Key of A2]
        NOTE3   $1C, C2, E3, C4
        NOTE3   FS3, G1, E3, C4
        NOTE3   $18, C1, E3, C4
        DSJNZ   L28A3

        NOTE3   $18, C1, E3, C4
        QUIET

L296E:
        NOTE3   $0C, G1, B1, D2
        NOTE3   $0C, G1, B1,DS2
        NOTE3   $0C, C1, E2, G8
        NOTE3   $0C, C1, C3, G8
        NOTE3   $0C, E1, G1, C2
        NOTE3   $0C, E1, G1, E2
        NOTE3   $18, G0, G1, C3
        NOTE3   $0C, G1,AS1, E2
        NOTE3   $0C, G1,AS1, C3
        NOTE3   $18, F1, F2, C3
        NOTE3   $18, A1, C2, C3
        RET

L299B:
        NOTE3   $0B, E1, E2, C3
        REST    $01
        NOTE3   $0C, E1, E2, C3
        NOTE3   $0C, G1, F2, D3
        NOTE3   $0C, G1,FS2,DS3
        NOTE3   $0C, G0, G2, E3
        NOTE3   $0C, G0, E2, C3
        NOTE3   $0C, E1, F2, D3
        NOTE3   $0C, E1, G2, E3
        NOTE3   $0C, G0, G2, E3
        NOTE3   $0C, G0, F2, B2
        NOTE3   $18, G1, F2, D3
        NOTE3   $18, C1, E2, C3
        NOTE3   $18, E1, G1, C3
        RET

L29D2:                  ; "Wolf Whistle" music score (Voices Mask = $0C)
        VOLUME  $00,$07
        LEGSTA                  ; Set Legato
        MASTER  $29
        ; Duration= TC=
        NOTE1   $03, E3
        MASTER  $28
        NOTE1   $03, E3
        MASTER  $26
        NOTE1   $03, E3
        MASTER  $24
        NOTE1   $03, E3
        MASTER  $22
        NOTE1   $03, E3
        MASTER  $20
        NOTE1   $02, E3
        MASTER  $29
        NOTE1   $02, E3
        MASTER  $28
        NOTE1   $02, E3
        MASTER  $26
        NOTE1   $02, E3
        MASTER  $24
        NOTE1   $02, E3
        MASTER  $26
        NOTE1   $02, E3
        MASTER  $28
        NOTE1   $02, E3
        MASTER  $29
        NOTE1   $06, E3
        QUIET

L2A0B:                  ; "Aw! Too Bad!" music score (Voices Mask = $CC)
        MASTER  $46             ; [OA2 - 1 ?? almost Key of A2]
        VOLUME  $07,$07
        LEGSTA                  ; Set Legato
        OUTPUT  $04,$81         ; VF = 1, VR =2
        PUSHN   $02
L2A14:
        ; Duration= TC=     TA=
        NOTE2   $3C, A1,     A2
        NOTE2   $3C, F2,     F3
        NOTE2   $57, E2,     E3
        REST    $03
        NOTE2   $1E, D2,     D3
        NOTE2   $3C, C2,     C3
        NOTE2   $3C, G1,     G2
        NOTE2   $41, A1,     A2
        NOTE2   $28, D2,     D3
        NOTE2   $14, C2,     C3
        NOTE2   $28, F1,     F2
        NOTE2   $14, G1,     G2
        NOTE2   $3C, F1,     F2
        NOTE2   $3C, E1,     E2
        NOTE2   $57,AS1,    AS2
        REST    $03
        NOTE2   $1E, C2,     C3
        NOTE2   $3C,AS1,    AS2
        NOTE2   $41, A1,     A2
        REST    $02
        MASTER  OA3             ; [$23 for Key of A3]
        DSJNZ   L2A14

        QUIET

L2A53:                  ; "Explosion" music score (Voices Mask = $FC)
        MASTER  $00
        VOLUME  $FF,$1F         ; NM = 1
        LEGSTA                  ; Set Legato
        OUTPUT  $07,$FF         ; NV = $FF
        CALL    L2A7F

        VOLUME  $AA,$1A         ; NM = 1
        CALL    L2A7F

        VOLUME  $99,$19         ; NM = 1
        CALL    L2A7F

        VOLUME  $55,$15         ; NM = 1
        ; Duration= TC= TB= TA=
        NOTE3   $08,$FF,$F6,$FD ; [use Non-Name notes for this one, too]
        PUSHN   $03
L2A72:
        CREL    $0C             ; do L2A7F

        DSJNZ   L2A72

        VOLUME  $11,$11         ; NM = 1
        PUSHN   $08
L2A7A:
        CREL    $04             ; do L2A7F

        DSJNZ   L2A7A

        QUIET

L2A7F:
        NOTE3   $04,$FF,$F6,$FD
        RET

L2A84:                  ; "Clementine" music score (Voices Mask = $0C)
        PUSHN   $02
L2A85:
        MASTER  $30
        VOICEM  $0C
        VOLUME  $56,$07
        OUTPUT  $01,         G8 ; Set TA
        OUTPUT  $02,     G8     ; Set TB
        ; Duration= TC=
        NOTE1   $12, C2
        NOTE1   $09, C2
        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $1B, C2, G1, E1
        VOICEM  $0C
        NOTE1   $1B, G1
        NOTE1   $12, E2
        NOTE1   $09, E2
        NOTE1   $1B, E2
        NOTE1   $1B, C2
        NOTE1   $12, C2
        NOTE1   $09, E2
        NOTE1   $24, G2
        NOTE1   $0E, G2
        NOTE1   $0D, F2
        NOTE1   $0E, E2
        VOICEM  $FC
        NOTE3   $36, D2, G1, B1
        VOICEM  $0C
        NOTE1   $12, D2
        NOTE1   $09, E2
        NOTE1   $1B, F2
        NOTE1   $1B, F2
        NOTE1   $12, E2
        NOTE1   $09, D2
        VOICEM  $FC
        NOTE3   $1B, E2, C2, G1
        VOICEM  $0C
        NOTE1   $1B, C2
        NOTE1   $12, C2
        NOTE1   $09, E2
        VOICEM  $FC
        NOTE3   $1B, D2, G1, B1
        NOTE3   $1B, G1, D1, B0
        NOTE3   $12, B1, G1, D1
        NOTE3   $09, D2, G1, B1
        NOTE3   $36, C2, G1, E1
        DSJNZ   L2A85

        NOTE3   $36, C2, F1, A1
        NOTE3   $36,GS1, F1, C1
        NOTE3   $3C, C1, E1, G1
        QUIET

L2AFA:                  ; "3 Tags" music score (Voices Mask = $0C)
        MASTER  $19
        VOLUME  $77,$07
        ; Duration= TC=
        NOTE1   $0E, G1
        NOTE1   $0E,FS1
        NOTE1   $0E, G1
        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $0E, B1,FS1, C1
        NOTE3   $1C, A1,FS1, C1
        VOICEM  $0C
        NOTE1   $03, D1
        NOTE1   $02, D1
        VOICEM  $FC
        NOTE3   $0E, B1,FS1, C1
        NOTE3   $0E, A1,FS1, C1
        NOTE3   $0E, D1, C1,FS1
        NOTE3   $1C, G1, D1, B0
        NOTE3   $0E, D2, G1, B0
        NOTE3   $0E,CS2, E1,AS0
        NOTE3   $0E, C2, E1, A0
        NOTE3   $38, B1, D1, G0
        REST    $20
        NOTE3   $10, E1, A0, C1
        VOICEM  $0C
        NOTE1   $10, E1
        NOTE1   $10,DS1
        NOTE1   $10, E1
        OUTPUT  $01,        CS1 ; Set TA
        OUTPUT  $02,    AS0     ; Set TB
        NOTE1   $10, G1
        NOTE1   $18,FS1
        NOTE1   $08, E1
        OUTPUT  $01,         G0
        OUTPUT  $02,     B0
        NOTE1   $10, D1
        NOTE1   $10, E1
        NOTE1   $10,FS1
        OUTPUT  $01,         E1
        OUTPUT  $02,     B0
        NOTE1   $20, G1
        NOTE1   $08, A1
        NOTE1   $08, B1
        VOICEM  $FC
        NOTE3   $30, E1,CS1, B0
        NOTE3   $30,FS1, D1, C1
        MASTER  $33
        LEGSTA                  ; Set Legato
        NOTE3   $10, G2, D2, B1
        VOICEM  $30
        ; Duration=     TB=
        NOTE1   $10,     D1
        NOTE1   $10,     B0
        NOTE1   $10,     G0
        REST    $20
        MASTER  $20
        PUSHN   $02
        LEGSTA                  ; Set Staccato
L2B82:
        VOICEM  $3C
        OUTPUT  $01,        DS1 ; Set TA
        ; Duration= TC= TB=
        NOTE2   $0A,AS1, G1
        NOTE2   $0A, A1,FS1
        NOTE2   $0A,AS1, G1
        VOICEM  $C0
        ; Duration=         TA=
        OUTPUT  $01,        AS1         ; (overwritten ??)
        NOTE1   $0F,        DS2
        NOTE1   $05,        DS2
        NOTE1   $14,        DS2
        REST    $0A
        OUTPUT  $01,         B0
        VOICEM  $3C
        NOTE2   $0A, G1,DS1
        NOTE2   $0A,FS1, D1
        NOTE2   $0A, G1,DS1
        VOICEM  $C0
        NOTE1   $0F,        AS1
        NOTE1   $05,         G1
        NOTE1   $14,        DS1
        REST    $0A
        VOICEM  $3C
        OUTPUT  $01,         B0
        NOTE2   $0A,DS1, G1
        NOTE2   $0A, F1, D1
        NOTE2   $0A,DS1, C1
        VOICEM  $FC
        NOTE3   $0F, F1, D1,GS0
        NOTE3   $05, F1, D1,GS0
        NOTE3   $14, F1, D1,GS0
        REST    $0A
        NOTE3   $0A,GS1, D1, C1
        NOTE3   $0A, G1, D1,AS0
        NOTE3   $0A, F1, D1,GS0
        NOTE3   $0F,AS1,DS1, G1
        NOTE3   $05, G1,DS1, A0
        NOTE3   $14,DS1,AS0, G0
        VOICEM  $3C
        REST    $0A
        DSJNZ   L2B82

        QUIET

L2BEF:                  ; "Meadowlands" music score (Voices Mask = $0C)
        VOLUME  $00,$07
        MASTER  $46             ; [OA2 - 1 ?? almost Key of A2]
        CALL    L2C46

        CALL    L2C46

        VOLUME  $57,$07
        CALL    L2C46

        CALL    L2C6F

        CALL    L2C90

        CALL    L2CA5

        CALL    L2C90

        VOICEM  $3C
        LEGSTA                  ; Set Legato
        OUTPUT  $01,         E2 ; Set TA
        PUSHN   $04
L2C12:
        ; Duration= TC= TB=
        NOTE2   $18, B0,GS1
        DSJNZ   L2C12

        LEGSTA                  ; Set Staccato
        CALL    L2C46

        CALL    L2C6F

        CALL    L2C90

        CALL    L2CA5

        CALL    L2C90

        CALL    L2CA5

        VOICEM  $C0
        OUTPUT  $01,         E1         ; (overwritten ??)
        OUTPUT  $03, C1         ; Set TC
        ; Duration=         TA=
        NOTE1   $18,         A2
        NOTE1   $0C,         G2
        NOTE1   $0E,         F2
        NOTE1   $10,         E2
        NOTE1   $12,         F2
        NOTE1   $16,         G2
        NOTE1   $1A,         A2
        VOICEM  $FC
        ; Duration= TC= TB= TA=
        NOTE3   $60, E3,GS1, B0
        QUIET

L2C46:
        VOICEM  $0C
        LEGSTA                  ; Set Legato
        OUTPUT  $02,     E2     ; Set TB
        OUTPUT  $01,         C3 ; Set TA
        ; Duration= TC=
        NOTE1   $0C, A0
        NOTE1   $0C, B0
        NOTE1   $0C, C1
        NOTE1   $0C, D1
        LEGSTA                  ; Set Staccato
        OUTPUT  $01,         A2
        NOTE1   $18, E1
        OUTPUT  $01,         C3
        NOTE1   $18, E1
        LEGSTA                  ; Set Legato
        OUTPUT  $01,         B2
        NOTE1   $18, B0
        NOTE1   $18, E1
        LEGSTA                  ; Set Staccato
        OUTPUT  $01,         G2
        NOTE1   $18, E1
        OUTPUT  $01,         E2
        NOTE1   $18, E1
        RET

L2C6F:
        VOICEM  $C0
        OUTPUT  $03, A0         ; Set TC
        LEGSTA                  ; Set Legato
        ; Duration=         TA=
        NOTE1   $0C,         C3
        NOTE1   $0C,         B2
        OUTPUT  $03, E1
        NOTE1   $0C,         A2
        NOTE1   $0C,        GS2
        LEGSTA                  ; Set Staccato
        NOTE1   $18,         A2
        NOTE1   $18,         C3
        VOICEM  $0C
        OUTPUT  $01,         B2
        NOTE1   $18, B0
        NOTE1   $18, E1
        NOTE1   $18, F1
        NOTE1   $18, E1
        RET

L2C90:
        VOICEM  $C0
        OUTPUT  $02,     F1
        OUTPUT  $03, C1
        NOTE1   $18,         A2
        NOTE1   $0C,         G2
        NOTE1   $0C,         F2
        NOTE1   $0C,         E2
        NOTE1   $0C,         D2
        NOTE1   $0C,         E2
        NOTE1   $0C,         F2
        RET

L2CA5:
        VOICEM  $C0
        LEGSTA                  ; Set Legato
        OUTPUT  $03, B0
        OUTPUT  $02,     E2
        NOTE1   $18,         E2
        NOTE1   $18,         B2
        NOTE1   $18,        GS2
        NOTE1   $18,         E2
        LEGSTA                  ; Set Staccato
        RET

L2CB6:                  ; "Anchors Aweigh" music score (Voices Mask = $FC)
        VOLUME  $67,$07
        OUTPUT  $04,$81         ; VF = 1, VR = 2
        LEGSTA                  ; Set Legato
        MASTER  $39
        PUSHN   $02
L2CBF:
        CALL    L2CD7

        CALL    L2D0E

        CALL    L2D2B

        CALL    L2CD7

        CALL    L2D0E

        CALL    L2D4C

        MASTER  $20
        DSJNZ   L2CBF

        QUIET

L2CD7:
        VOICEM  $FC
        NOTE3   $3C, E1, G1, C2
        NOTE3   $1E, G1, C2, E2
        NOTE3   $1E, C2, E2, G2
        NOTE3   $2D, C2, E2, A2
        NOTE3   $0F, A1, C2, E2
        NOTE3   $3C, C2, E2, A2
        NOTE3   $3C, E2, G2, C3
        NOTE3   $1E,FS2, A2, D3
        NOTE3   $1E, D2, F2, G2
        NOTE3   $1E, E2, G2, C3
        NOTE3   $1E, E2, A1, C3
        NOTE3   $1E, E2, G1, C3
        NOTE3   $1E, E2, E1, C3
        RET

L2D0E:
        NOTE3   $3C, C2, F2, A2
        NOTE3   $1E, F2, A2, C3
        NOTE3   $1E, C2, F2, A2
        NOTE3   $1E, C2, E2, G2
        NOTE3   $1E, C2,FS2, A2
        NOTE3   $1E, D2, F2, B2
        NOTE3   $1E, E2, G2, C3
        RET

L2D2B:
        NOTE3   $1E, A1, D2,FS2
        NOTE3   $1E, D2,FS2, A2
        NOTE3   $1E,FS2, A2, D3
        NOTE3   $1E,FS2, A2, C3
        NOTE3   $1E, D2, G2, B2
        NOTE3   $1E, B1, D2, G2
        NOTE3   $1E, A1, C2, F2
        NOTE3   $1E, F1, G1, D2
        RET

L2D4C:
        NOTE3   $17, G2, C3, E3
        NOTE3   $07, G2, G8, G1
        VOICEM  $CC
        NOTE2   $0F,FS2,    FS1
        NOTE2   $0F, G2,     G1
        OUTPUT  $02,     F2     ; Set TB
        NOTE2   $17, G2,     D3
        OUTPUT  $02,     G8
        NOTE2   $07, G2,     G1
        NOTE2   $0F,FS2,    FS1
        NOTE2   $0F, G2,     G1
        VOICEM  $FC
        NOTE3   $3C, E2, C3, G2
        NOTE3   $3C, E3, C4, G3
        RET

L2D77:                  ; "Lida Rose" music score (Voices Mask = $FC)
        MASTER  $30
        VOLUME  $65,$05
        CALL    L2EFB

        LEGSTA                  ; Set Legato
        NOTE3   $14,DS2, C2,FS1
        NOTE3   $0A,DS2, C2, A1
        NOTE3   $1E,DS2, C2, A1
        NOTE3   $78, E2, C2, G1
        LEGSTA                  ; Set Staccato
        CALL   L2E82

        NOTE3   $1E, D2, B1, F1
        NOTE3   $1E, E2, C2, G1
        NOTE3   $78,DS2, F1, C1
        NOTE3   $3C, F2, D2,AS0
        NOTE3   $3C, D2,AS1, F1
        NOTE3   $5A, D2, F1,GS1
        NOTE3   $14, F2, D2,GS1
        NOTE3   $0A, F2,CS2,GS1
        NOTE3   $32, F2, C2, A1
        NOTE3   $0A, F2, A1, C1
        NOTE3   $14, F2, C2, A1
        NOTE3   $0A, F2, A1, F1
        NOTE3   $1E, F2, C2,DS1
        NOTE3   $3C,FS2,AS1, D1
        NOTE3   $3C,FS2,AS1, C2
        NOTE3   $3C, F2, A1, B1
        NOTE3   $3C, D2, F1, B1
        NOTE3   $5A, F2, D1, G0
        NOTE3   $14, F2, D1, G0
        NOTE3   $0A, D2, F1, G0
        NOTE3   $1E, C2, E1,AS0
        NOTE3   $1E, D2, F1, B0
        NOTE3   $1E, E2, G1, C1
        NOTE3   $1E,DS2, A1,FS1
        NOTE3   $1E, E2, C2, G1
        NOTE3   $14,DS2, B1,FS1
        NOTE3   $0A, E2, C2, G1
        NOTE3   $1E, E2,AS1, C2
        NOTE3   $1E, E2, G1, C1
        CALL    L2E82

        NOTE3   $1E, F2, B1,GS1
        LEGSTA                  ; Set Legato
        NOTE3   $0F, F2, C2, A1
        NOTE3   $3C, G2,DS2, C1
        NOTE3   $08, A2,DS2, C1
        NOTE3   $08, G2,DS2, C1
        NOTE3   $41,FS2, D2, A1
        LEGSTA                  ; Set Staccato
        CALL    L2EFB

        NOTE3   $3C, G2, C2,DS1
        LEGSTA                  ; Set Legato
        NOTE3   $5A,FS2, E2, A1
        NOTE3   $5A,FS2, D2, A1
        REST    $1E
        NOTE3   $1E, F2, D2, G1
        NOTE3   $0F, F2,CS2, G1
        NOTE3   $2D, F2, D2, G1
        NOTE3   $2D, G2, D2, F1
        NOTE3   $2D, G2, D2, E1
        NOTE3   $2D, F2,CS2, G1
        NOTE3   $2D, E2, C2, G1
        NOTE3   $2D, E2,AS2,CS2
        MASTER  $60
        VOICEM  $CC
        OUTPUT  $02,     C4     ; Set TB
        NOTE2   $2D, A3,     C3
        PUSHN   $02
L2E61:
        NOTE2   $1E, A3,     C2
        NOTE2   $0F,GS3,     B1
        NOTE2   $2D, A3,     C2
        NOTE2   $2D, C3,     C2
        DSJNZ   L2E61

        NOTE2   $2D, A3,     C2
        NOTE2   $17,GS3,     B1
        NOTE2   $5A, A3,     C2
        OUTPUT  $02,     F4
        VOLUME  $45,$04
        NOTE2   $5A, A3,     F1
        QUIET

L2E82:
        REST    $1E
        NOTE3   $14, F2, A1, C2
        NOTE3   $0A, F2,GS1, C2
        NOTE3   $1E, F2, A1, C2
        NOTE3   $1E, F2, C1, A1
        NOTE3   $14,DS2, A1,FS1
        NOTE3   $0A,DS2,GS1,FS1
        NOTE3   $14,DS2, A1, C2
        NOTE3   $28,DS2, C1,FS1
        NOTE3   $0A,DS2, A1, C2
        NOTE3   $14,DS2,GS1, C2
        NOTE3   $0A,DS2, A1, C2
        NOTE3   $1E, E2, D2,AS1
        NOTE3   $1E, E2, C2, G1
        NOTE3   $1E,DS2, B1,FS1
        NOTE3   $1E, E2, C2, G1
        NOTE3   $78, E2,AS1, C1
        REST    $1E
        NOTE3   $14, E2,AS1, G1
        NOTE3   $0A,DS2, A1,FS1
        NOTE3   $1E, E2,AS1, G1
        NOTE3   $1E, E2, C1, G1
        NOTE3   $14, D2, B1, E1
        NOTE3   $0A, D2,AS1,GS1
        NOTE3   $14, D2, B1,GS1
        NOTE3   $28, E2, B1, D2
        NOTE3   $0A, D2, B1,GS1
        NOTE3   $14, D2,AS1,GS1
        NOTE3   $0A, D2, B1, E1
        NOTE3   $1E, F2, D2, A1
        NOTE3   $1E, F2, C2, A1
        RET

L2EFB:
        REST    $1E
        NOTE3   $1E, F2, D2,AS0
        NOTE3   $14, F2, D2,AS0
        NOTE3   $0A, F2,CS2,AS0
        NOTE3   $1E, F2, D2,AS0
        NOTE3   $3C, D2, F1,AS1
        NOTE3   $3C,CS2, G1, F1
        NOTE3   $1E, F1, G8, G8
        NOTE3   $1E, F2, A1, C2
        NOTE3   $14, F2, C2, A1
        NOTE3   $0A, F2, A1, F1
        NOTE3   $1E, F2, C2,DS1
        NOTE3   $3C,FS2, E2, D1
        NOTE3   $3C,FS2, E2, A1
        REST    $1E
        NOTE3   $17, F2, D2, G1
        NOTE3   $07, F2,CS2, G1
        NOTE3   $1E, F2, D2, G1
        NOTE3   $1E, F2,AS1, D1
        NOTE3   $1E, E2, A1, C1
        NOTE3   $14, F2,GS1, D1
        NOTE3   $3C, E2, G1, C1
        NOTE3   $3C, F2, A1, F1
        RET

        DB      $06,$04,$02,$00,$FE,$FC,$FA,$00         ; Eight Random Bytes

        DB      $FF,$FF,$FF,$FF         ; Fill to end with 255's to match ROM
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

                        ; L2FFF = End of Code
